
; PicBasic Pro Compiler 2.04,  Copyright (c) 1998 microEngineering Labs, Inc.     All Rights Reserved.

PM_USED			EQU	1

	INCLUDE	"PBPPROC.INC"

RAM_START       		EQU	0000Ch
RAM_END         		EQU	0004Fh
RAM_BANKS       		EQU	00001h
BANK0_START     		EQU	0000Ch
BANK0_END       		EQU	0004Fh
EEPROM_START    		EQU	02100h
EEPROM_END      		EQU	0213Fh

R0              		EQU	RAM_START + 000h
R1              		EQU	RAM_START + 002h
R2              		EQU	RAM_START + 004h
R3              		EQU	RAM_START + 006h
R4              		EQU	RAM_START + 008h
R5              		EQU	RAM_START + 00Ah
R6              		EQU	RAM_START + 00Ch
R7              		EQU	RAM_START + 00Eh
T1              		EQU	RAM_START + 010h
T2              		EQU	RAM_START + 012h
T3              		EQU	RAM_START + 014h
FLAGS           		EQU	RAM_START + 016h
GOP             		EQU	RAM_START + 017h
RM1             		EQU	RAM_START + 018h
RM2             		EQU	RAM_START + 019h
RR1             		EQU	RAM_START + 01Ah
RR2             		EQU	RAM_START + 01Bh
_addr            		EQU	RAM_START + 01Ch
_B0              		EQU	RAM_START + 01Dh
_B1              		EQU	RAM_START + 01Eh
_B2              		EQU	RAM_START + 01Fh
_B3              		EQU	RAM_START + 020h
_N               		EQU	RAM_START + 021h
_PORTL           		EQU	PORTB
_PORTH           		EQU	PORTA
_TRISL           		EQU	TRISB
_TRISH           		EQU	TRISA
#define _D4              	_PORTA_0
#define _D5              	_PORTA_1
#define _D6              	_PORTA_2
#define _D7              	_PORTA_3
#define _RS              	_PORTA_4
#define _SW              	_PORTB_0
#define _SDA             	_PORTB_1
#define _SCL             	_PORTB_2
#define _EN              	_PORTB_3
#define _RLY             	_PORTB_4
#define _BUZ             	_PORTB_5
#define _FR0             	_PORTB_6
#define _FR1             	_PORTB_7
#define _PORTA_0         	PORTA, 000h
#define _PORTA_1         	PORTA, 001h
#define _PORTA_2         	PORTA, 002h
#define _PORTA_3         	PORTA, 003h
#define _PORTA_4         	PORTA, 004h
#define _PORTB_0         	PORTB, 000h
#define _PORTB_1         	PORTB, 001h
#define _PORTB_2         	PORTB, 002h
#define _PORTB_3         	PORTB, 003h
#define _PORTB_4         	PORTB, 004h
#define _PORTB_5         	PORTB, 005h
#define _PORTB_6         	PORTB, 006h
#define _PORTB_7         	PORTB, 007h

; Constants.

; Commands Used.
LCDOUT_USED     	= 	04Bh
CMPEQ_USED      	= 	00Eh
IF_USED         	= 	016h
GOTO_USED       	= 	008h
SOUNDPIN_USED   	= 	002h
SOUND_USED      	= 	002h
GOSUB_USED      	= 	012h
FOR_USED        	= 	003h
CMPGT_USED      	= 	006h
NEXT_USED       	= 	003h
RETURN_USED     	= 	004h
CMPNE_USED      	= 	001h
PAUSE_USED      	= 	008h
AND_USED        	= 	002h
SUB_USED        	= 	003h
CMPLT_USED      	= 	005h
CMPF_USED       	= 	00Ah
CMPT_USED       	= 	005h
ENDIF_USED      	= 	005h
OR_USED         	= 	004h
I2CDATA_USED    	= 	003h
I2CCLOCK_USED   	= 	003h
I2CWRITE_USED   	= 	00Ah
I2CREAD_USED    	= 	002h
END_USED        	= 	001h

	INCLUDE	"CTRLCARD.MAC"
	INCLUDE	"PBPPIC14.LIB"

	MOVE?CB	001h, TRISB
	MOVE?CB	000h, TRISA
_debut	
	MOVE?CT	000h, _RLY
	LCDOUT?C	0FEh
	LCDOUT?C	001h
	LCDOUT?C	020h
	LCDOUT?C	049h
	LCDOUT?C	04Eh
	LCDOUT?C	053h
	LCDOUT?C	045h
	LCDOUT?C	052h
	LCDOUT?C	045h
	LCDOUT?C	05Ah
	LCDOUT?C	020h
	LCDOUT?C	056h
	LCDOUT?C	04Fh
	LCDOUT?C	054h
	LCDOUT?C	052h
	LCDOUT?C	045h
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?C	020h
	LCDOUT?C	020h
	LCDOUT?C	020h
	LCDOUT?C	020h
	LCDOUT?C	043h
	LCDOUT?C	041h
	LCDOUT?C	052h
	LCDOUT?C	054h
	LCDOUT?C	045h
	LCDOUT?C	020h
	LCDOUT?C	021h
_detec	
	CMPEQ?TCL	_SW, 001h, _loop
	GOTO?L	_detec
_loop	
	SOUNDPIN?T	_BUZ
	SOUND?CC	064h, 03Ch
	MOVE?CB	003h, _addr
	GOSUB?L	_lect
	CMPEQ?BCL	_B0, 061h, _acces
	CMPEQ?BCL	_B0, 063h, _compt
	CMPEQ?BCL	_B0, 074h, _compt
	CMPEQ?BCL	_B0, 064h, _decod
	GOTO?L	_ejec
_affi	
	LCDOUT?C	0FEh
	LCDOUT?C	001h
	MOVE?CB	010h, _N
L00001	
	CMPGT?BCL	_N, 01Fh, L00002
	MOVE?BB	_N, _addr
	GOSUB?L	_lect
	LCDOUT?B	_B0
	ADD?BCB	_N, 001h, _N
	GOTO?L	L00001
L00002	
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	MOVE?CB	020h, _N
L00003	
	CMPGT?BCL	_N, 02Fh, L00004
	MOVE?BB	_N, _addr
	GOSUB?L	_lect
	LCDOUT?B	_B0
	ADD?BCB	_N, 001h, _N
	GOTO?L	L00003
L00004	
	RETURN?	
_acces	
	MOVE?CB	000h, _addr
	GOSUB?L	_lect
	CMPNE?BCL	_B0, 020h, _ejec
	MOVE?CT	001h, _RLY
	GOSUB?L	_affi
	MOVE?CB	004h, _addr
	GOSUB?L	_lect
	CMPEQ?BCL	_B0, 070h, _cart
	PAUSE?C	00BB8h
	GOTO?L	_debut
_cart	
	CMPEQ?TCL	_SW, 000h, _debut
	MOVE?CB	003h, _addr
	GOSUB?L	_lect
	CMPEQ?BCL	_B0, 074h, _time
	GOTO?L	_cart
_compt	
	MOVE?CB	000h, _addr
	GOSUB?L	_lect
	MOVE?BB	_B0, _B1
	MOVE?CB	001h, _addr
	GOSUB?L	_lect
	MOVE?BB	_B0, _B2
	MOVE?CB	002h, _addr
	GOSUB?L	_lect
	MOVE?BB	_B0, _B3
	GOSUB?L	_decomp
	MOVE?CT	001h, _RLY
	MOVE?CB	000h, _addr
	MOVE?BB	_B1, _B0
	GOSUB?L	_ecri
	MOVE?CB	001h, _addr
	MOVE?BB	_B2, _B0
	GOSUB?L	_ecri
	MOVE?CB	002h, _addr
	MOVE?BB	_B3, _B0
	GOSUB?L	_ecri
	GOSUB?L	_affi
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?B	_B1
	LCDOUT?B	_B2
	LCDOUT?B	_B3
	GOTO?L	_cart
_decomp	
	AND?CBW	030h, _B2, T1
	CMPEQ?BWB	_B1, T1, T1
	AND?CBW	030h, _B3, T2
	CMPEQ?BWB	T1, T2, T2
	CMPEQ?BCL	T2, 030h, _ejec
	SUB?BCB	_B3, 001h, _B3
	CMPLT?BCB	_B3, 030h, T1
	CMPF?BL	T1, L00005
	MOVE?CB	039h, _B3
	SUB?BCB	_B2, 001h, _B2
L00005	
	CMPLT?BCB	_B2, 030h, T1
	CMPF?BL	T1, L00007
	MOVE?CB	039h, _B2
	SUB?BCB	_B1, 001h, _B1
L00007	
	CMPGT?BCB	_B1, 039h, T1
	CMPGT?BCB	_B2, 039h, T2
	OR?BBW	T1, T2, T2
	CMPGT?BCB	_B3, 039h, T3
	OR?WBL	T2, T3, _ejec
	CMPLT?BCB	_B1, 030h, T1
	CMPLT?BCB	_B2, 030h, T2
	OR?BBW	T1, T2, T2
	CMPLT?BCB	_B3, 030h, T3
	OR?WBL	T2, T3, _ejec
	RETURN?	
_time	
	MOVE?CB	004h, _addr
	GOSUB?L	_lect
	CMPEQ?BCB	_B0, 064h, T1
	CMPF?BL	T1, L00009
	PAUSE?C	02710h
L00009	
	CMPEQ?BCB	_B0, 06Dh, T1
	CMPF?BL	T1, L00011
	PAUSE?C	0EA60h
L00011	
	CMPEQ?BCB	_B0, 068h, T1
	CMPF?BL	T1, L00013
	MOVE?CB	000h, _N
L00015	
	CMPGT?BCL	_N, 03Ch, L00016
	PAUSE?C	0EA60h
	ADD?BCB	_N, 001h, _N
	GOTO?L	L00015
L00016	
L00013	
	GOTO?L	_compt
_decod	
	MOVE?CB	000h, _addr
	GOSUB?L	_lect
	MOVE?BB	_B0, _B1
	I2CDATA?T	_SDA
	I2CCLOCK?T	_SCL
	I2CWRITE?C	041h
	I2CWRITE?C	000h
	I2CWRITES?B	_B0
	GOSUB?L	_affi
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?B	_B1
	PAUSE?C	00BB8h
	GOTO?L	_debut
_ecri	
	I2CDATA?T	_SDA
	I2CCLOCK?T	_SCL
	I2CWRITE?C	0A0h
	I2CWRITE?B	_addr
	I2CWRITES?B	_B0
	PAUSE?C	014h
	RETURN?	
_lect	
	I2CDATA?T	_SDA
	I2CCLOCK?T	_SCL
	I2CWRITE?C	0A0h
	I2CWRITE?B	_addr
	I2CREADS?B	_B0
	PAUSE?C	014h
	RETURN?	
_ejec	
	LCDOUT?C	0FEh
	LCDOUT?C	001h
	LCDOUT?C	043h
	LCDOUT?C	061h
	LCDOUT?C	072h
	LCDOUT?C	074h
	LCDOUT?C	065h
	LCDOUT?C	020h
	LCDOUT?C	045h
	LCDOUT?C	070h
	LCDOUT?C	075h
	LCDOUT?C	069h
	LCDOUT?C	073h
	LCDOUT?C	065h
	LCDOUT?C	065h
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?C	04Fh
	LCDOUT?C	075h
	LCDOUT?C	020h
	LCDOUT?C	04Eh
	LCDOUT?C	06Fh
	LCDOUT?C	06Eh
	LCDOUT?C	020h
	LCDOUT?C	056h
	LCDOUT?C	061h
	LCDOUT?C	06Ch
	LCDOUT?C	061h
	LCDOUT?C	062h
	LCDOUT?C	06Ch
	LCDOUT?C	065h
	LCDOUT?C	021h
	SOUNDPIN?T	_BUZ
	SOUND?CC	032h, 0012Ch
	PAUSE?C	00BB8h
	GOTO?L	_debut
	END?	

	END
